      subroutine matdex(nmax,etol,a,daexp,ierr)
      implicit double precision (a-h,o-z)
      dimension a(3,3),daexp(3,3,3,3)
      dimension an(20,3,3),tmpa(3,3,3,3),dn(20)
      common /iofile/ior1,ior2,ior3,ior4,ior5,
     &               iow1,iow2,iow3,iow4,iow5,
     &               iow6,iow7,iow8,iow9,iow10
      common /etc/del(3),delta(3,3),p(3,3,3),dpai
c
c     compute derivative of exponential function of a matrix A(i,j)
c
c ----- check array size limit
      if(nmax.gt.20) then
       write(iow1,*) '--- too large nmax is specified in matdex.'
       write(   *,*) '--- too large nmax is specified in matdex.'
       stop
      end if
c
c ----- initialize error flag
      ierr = 0
c
c ----- compute A(i,j)^n and n-factorial for n = 1, ..., nx,
c       which satisfies (1/nx!) ||A^(nx)|| < etol.
c   --- n = 1
      dd = 0.0d0
      do i=1,3
       do j=1,3
        an(1,i,j) = a(i,j)
        dd = dd+an(1,i,j)**2
       end do
      end do
      dd = dsqrt(dd)
      dn(1) = 1.0d0
      dx = dd/dn(1)
      if(dx.lt.etol) then
       ierr = 1
       nx = 1
       goto 110
      end if
c   --- n = 2, 3, ..., nx
      ik = 2
  100 continue
       dd = 0.0d0
       do i=1,3
        do j=1,3
         an(ik,i,j) = an(ik-1,i,1)*a(1,j)
     &               +an(ik-1,i,2)*a(2,j)
     &               +an(ik-1,i,3)*a(3,j)
         dd = dd+an(ik,i,j)**2
        end do
       end do
       dd = dsqrt(dd)
       dn(ik) = dn(ik-1)*dble(ik)
       dx = dd/dn(ik)
       if(dx.lt.etol) then
        ierr = ik
        nx = ik
        goto 110
       else if((ik.lt.nmax).and.(dx.ge.etol)) then
        ik = ik+1
        goto 100
       else if((ik.ge.nmax).and.(dx.ge.etol)) then
        ierr = -1
        ik = nmax
        goto 110
       end if
  110 continue
c
c ----- daexp(i,j,k,l) = (1st term) + (2nd term)
      do i=1,3
       do j=1,3
        do k=1,3
         do l=1,3
          daexp(i,j,k,l) = delta(i,k)*delta(l,j)
          if(nx.ge.2) then
           daexp(i,j,k,l) = daexp(i,j,k,l)
     &                  +(delta(i,k)*a(l,j)+a(i,k)*delta(l,j))/dn(2)
          end if
         end do
        end do
       end do
      end do
c
      if(nx.le.2) then
       goto 900
      end if
c
c ----- compute 3rd and higher order (p-th) terms...
      do 200 ip=3,nx
       do i=1,3
        do j=1,3
         do k=1,3
          do l=1,3
c     ----- compute 1st term in p-th term
           tmpa(i,j,k,l) = delta(i,k)*an(ip-1,l,j)/dn(ip)
           do 210 iq=2,ip-1
c     ----- compute q-th term in p-th term
            tmpa(i,j,k,l) = tmpa(i,j,k,l)
     &                     +an(iq-1,i,k)*an(ip-iq,l,j)/dn(ip)
  210      continue
c     ----- compute p-th (last) term in p-th term
           tmpa(i,j,k,l) = tmpa(i,j,k,l)
     &                    +an(ip-1,i,k)*delta(l,j)/dn(ip)
c   ----- compute p-th term
           daexp(i,j,k,l) = daexp(i,j,k,l)+tmpa(i,j,k,l)
          end do
         end do
        end do
       end do
  200 continue
c
  900 continue
      return
      end subroutine matdex
