      subroutine matexp(nmax,etol,a,aexp,ierr)
      implicit double precision (a-h,o-z)
      dimension a(3,3),aexp(3,3),an(3,3),atmp(3,3)
      common /iofile/ior1,ior2,ior3,ior4,ior5,
     &               iow1,iow2,iow3,iow4,iow5,
     &               iow6,iow7,iow8,iow9,iow10
      common /etc/del(3),delta(3,3),p(3,3,3),dpai
c
c     compute exponential of a matrix A(3,3)
c     based on the Taylow series expansion:
c        exp[A(i,j)] = SUM_{n=0}^{nmax} (1/n!) A(i,j)^n,
c     with nmax such that 
c        (1/nmax!) ||A^(nmax)|| < etol.
c
c ----- initialize matrix (identity matrix as 0-th order approximation)
      aexp(1:3,1:3) = delta(1:3,1:3)
      an(1:3,1:3)   = delta(1:3,1:3)
      atmp(1:3,1:3) = delta(1:3,1:3)
c
c ----- initialize factorial of n and error flag
      dn = 1.0d0
      ierr = 0
c
c ----- 0-th order approximation
      if(nmax.eq.0) then
       goto 900
      end if
c
      n = 1
  100 continue
c
c ----- compute A(3,3)^n and its norm
      an(1:3,1:3) = matmul(atmp(1:3,1:3),a(1:3,1:3))
      dd = 0.0d0
      do i=1,3
       do j=1,3
        dd = dd+an(i,j)**2
       end do
      end do
      dd = dsqrt(dd)
      atmp(1:3,1:3) = an(1:3,1:3)
c
c ----- compute factorial of n
      dn = dn*dble(n)
c
c ----- compute n-th order approximation of exp[A(3,3)]
      aexp(1:3,1:3) = aexp(1:3,1:3)+an(1:3,1:3)/dn
c
c ----- check convergence
      dx = dd/dn
      if(dx.lt.etol) then
       ierr = n
       goto 900
      else if((n.lt.nmax).and.(dx.ge.etol)) then
       n = n+1
       goto 100
      else if((n.ge.nmax).and.(dx.ge.etol)) then
       ierr = -1
       goto 900
      end if
  900 continue
c
      return
      end subroutine matexp
