      subroutine retmap(inel,ige,mtypee,prope,
     &                  fr,djr,
     &                  ft,dj,fe,dje,fp,djp,sg,idep,xp,
     &                  ftn,djn,fen,djen,fpn,djpn,sgn,idepn,xpn)
      implicit double precision (a-h,o-z)
      dimension prope(20)
      dimension fr(3,3)
      dimension ft(3,3),fe(3,3),fp(3,3),sg(3,3),xp(30)
      dimension ftn(3,3),fen(3,3),fpn(3,3),sgn(3,3),xpn(30)
      dimension iwork(6)
      dimension ctn(3,3),ctninv(3,3)
      dimension cptr(3,3),cptrinv(3,3),cpdtr(3,3),cpdtrinv(3,3)
      dimension st20tr(3,3),st30tr(3,3)
      dimension sk20tr(3,3),sk30tr(3,3)
      dimension sx30tr(3,3),sx30trd(3,3)
      dimension cpn(3,3),cpninv(3,3),cpdn(3,3),cpdninv(3,3)
      dimension st20n(3,3),st30n(3,3)
      dimension sk20n(3,3),sk30n(3,3),sk30nd(3,3)
      dimension tge30cp(3,3,3,3),tgk30cp(3,3,3,3),tgk30cpd(3,3,3,3)
      dimension sx30n(3,3),sx30nd(3,3)
      dimension dfst(3,3),dfsk(3,3)
      dimension gp(3,3),gk(3,3),dgp(3,3,3,3),dgk(3,3,3,3)
      dimension q1tmp(3,3),q1exp(3,3),dq1exp(3,3,3,3)
      dimension q2tmp(3,3),q2exp(3,3),dq2exp(3,3,3,3)
      dimension dq11(3,3,3,3),dq12(3,3,3,3),dq13(3,3),dq14(3,3)
      dimension dq21(3,3,3,3),dq22(3,3,3,3),dq23(3,3),dq24(3,3)
      dimension tmp11(3,3,3,3),tmp12(3,3,3,3)
      dimension tmp21(3,3,3,3),tmp22(3,3,3,3)
      dimension y1(3,3),y2(3,3),y(14),dx(14),x1(14),aj(14,14)
      dimension aj11(3,3,3,3),aj12(3,3,3,3),aj13(3,3),aj14(3,3)
      dimension aj21(3,3,3,3),aj22(3,3,3,3),aj23(3,3),aj24(3,3)
      dimension aj31(3,3),aj32(3,3),aj41(3,3),aj42(3,3)
      common /iofile/ior1,ior2,ior3,ior4,ior5,
     &               iow1,iow2,iow3,iow4,iow5,
     &               iow6,iow7,iow8,iow9,iow10
      common /etc/del(3),delta(3,3),p(3,3,3),dpai
c
c ----- return-mapping algorithm for hyperelasto-plasticity model
c       with combined isotropic and kinematic hardening based on the
c       `dual' multiplicative decompositions
c       F = Fe * Fp and Fp = Fpe * Fpd.
c       The subloading surface concept is incorporated.
c       Tensor exponential-based algorithm is employed
c       for time integration of the plastic evolution equations.
c
c ----- material constants
c
c     prope( 1) : Lame' constant `lambda'
c     prope( 2) : Lame' constant `mu' (elastic shear modulus)
c     prope( 3) : ------
c     prope( 4) : evolution factor `u' of subloading surface
c     prope( 5) : elastic limit of normal-yield ratio `R_e'
c     prope( 6) : initial yield stress `F0'
c     prope( 7) : isotropic hardening (linear) `h0'
c     prope( 8) : isotropic hardening (saturation limit ratio) `h1'
c     prope( 9) : isotropic hardening (exponent coeff.) `h2'
c     prope(10) : ------
c     prope(11) : ------
c     prope(12) : shear modulus `c' for kinematic hardening
c     prope(13) : evolution factor `b' for kinematic hardening
c     prope(14) : ------
c     prope(15) : ------
c     prope(16) : ------
c     prope(17) : ------
c     prope(18) : ------
c     prope(19) : ------
c     prope(20) : ------
c
      dlam   = prope( 1)
      dmyu   = prope( 2)
c     ------ = prope( 3)
      u0     = prope( 4)
      rse    = prope( 5)
      yld0   = prope( 6)
      plhi0  = prope( 7)
      plhi1  = prope( 8)
      plhi2  = prope( 9)
c     ------ = prope(10)
c     ------ = prope(11)
      dmyuk  = prope(12)
      plhk   = prope(13)
c     ------ = prope(14)
c     ------ = prope(15)
c     ------ = prope(16)
c     ------ = prope(17)
c     ------ = prope(18)
c     ------ = prope(19)
c     ------ = prope(20)
c
c   --- to avoid zero-divide
      if(dmyuk.eq.0.0d0) then
       dmyuk = 1.0d-14
      end if
c
c ----- plastic internal variables
c
c     xp( 1) : incremental plastic multiplier
c     xp( 2) : strain-ordered variable for isotropic hardening
c     xp( 3) : normal-yield ratio `R' for subloading surface
c     xp( 4) : ------
c     xp( 5) : ------
c     xp( 6) : ------
c     xp( 7) : ------
c     xp( 8) : ------
c     xp( 9) : ------
c     xp(10) : ------
c     xp(11) : plastic right C-G deformation tensor `cptr(1,1)'
c     xp(12) : plastic right C-G deformation tensor `cptr(1,2)'
c     xp(13) : plastic right C-G deformation tensor `cptr(1,3)'
c     xp(14) : plastic right C-G deformation tensor `cptr(2,1)'
c     xp(15) : plastic right C-G deformation tensor `cptr(2,2)'
c     xp(16) : plastic right C-G deformation tensor `cptr(2,3)'
c     xp(17) : plastic right C-G deformation tensor `cptr(3,1)'
c     xp(18) : plastic right C-G deformation tensor `cptr(3,2)'
c     xp(19) : plastic right C-G deformation tensor `cptr(3,3)'
c     xp(20) : determinant of `cptr'
c     xp(21) : right C-G tensor for kinematic hardening `cpdtr(1,1)'
c     xp(22) : right C-G tensor for kinematic hardening `cpdtr(1,2)'
c     xp(23) : right C-G tensor for kinematic hardening `cpdtr(1,3)'
c     xp(24) : right C-G tensor for kinematic hardening `cpdtr(2,1)'
c     xp(25) : right C-G tensor for kinematic hardening `cpdtr(2,2)'
c     xp(26) : right C-G tensor for kinematic hardening `cpdtr(2,3)'
c     xp(27) : right C-G tensor for kinematic hardening `cpdtr(3,1)'
c     xp(28) : right C-G tensor for kinematic hardening `cpdtr(3,2)'
c     xp(29) : right C-G tensor for kinematic hardening `cpdtr(3,3)'
c     xp(30) : determinant of `cpdtr'
c
      dp         = xp( 1)
      xpitr      = xp( 2)
      rstr       = xp( 3)
c     ------     = xp( 4)
c     ------     = xp( 5)
c     ------     = xp( 6)
c     ------     = xp( 7)
c     ------     = xp( 8)
c     ------     = xp( 9)
c     ------     = xp(10)
      cptr(1,1)  = xp(11)
      cptr(1,2)  = xp(12)
      cptr(1,3)  = xp(13)
      cptr(2,1)  = xp(14)
      cptr(2,2)  = xp(15)
      cptr(2,3)  = xp(16)
      cptr(3,1)  = xp(17)
      cptr(3,2)  = xp(18)
      cptr(3,3)  = xp(19)
      djcptr     = xp(20)
      cpdtr(1,1) = xp(21)
      cpdtr(1,2) = xp(22)
      cpdtr(1,3) = xp(23)
      cpdtr(2,1) = xp(24)
      cpdtr(2,2) = xp(25)
      cpdtr(2,3) = xp(26)
      cpdtr(3,1) = xp(27)
      cpdtr(3,2) = xp(28)
      cpdtr(3,3) = xp(29)
      djcpdtr    = xp(30)
c
c ----- compute `updated' total right Cauchy-Green deformation tensor
c       and its inverse
      ctn(1:3,1:3) = matmul(transpose(ftn(1:3,1:3)),ftn(1:3,1:3))
      ctninv(1:3,1:3) = ctn(1:3,1:3)
c
      eps = 1.0d-18
      CALL tinvdd(3,ctninv,djctn,eps,3,iwork,ill)
c
c ----- compute inverse of trial values cptr(3,3) and cpdtr(3,3)
      cptrinv(1:3,1:3)  = cptr(1:3,1:3)
      cpdtrinv(1:3,1:3) = cpdtr(1:3,1:3)
c
      eps = 1.0d-18
      CALL tinvdd(3,cptrinv,djcptr,eps,3,iwork,ill)
      CALL tinvdd(3,cpdtrinv,djcpdtr,eps,3,iwork,ill)
c
c ----- compute trial 2nd Piola-Kirchhoff stress on reference config.
c       by neo-Hookean hyperelastic model
      st20tr(1:3,1:3)
     &  = (dlam/2.0d0)*(djctn/djcptr-1.0d0)*ctninv(1:3,1:3)
     &              +dmyu*(cptrinv(1:3,1:3)-ctninv(1:3,1:3))
c
c ----- convert trial 2nd Piola-Kirchhoff stress on reference config.
c       to trial (Eshelby-like) stress on reference config.
      st30tr(1:3,1:3) = matmul(ctn(1:3,1:3),st20tr(1:3,1:3))
c
c ----- compute trial 2nd Piola-Kirchhoff-type stress variable
c       for kinematic hardening on reference config.
c       by neo-Hookean-type model (only deviatoric part)
      sk20tr(1:3,1:3) = dmyuk*(cpdtrinv(1:3,1:3)-cptrinv(1:3,1:3))
c
c ----- convert trial 2nd Piola-Kirchhoff-type stress variable
c       for kinematic hardening to trial (Eshelby-like) back stress
c       on reference config.
      sk30tr(1:3,1:3) = matmul(cptr(1:3,1:3),sk20tr(1:3,1:3))
c
c ----- compute `reduced' (Eshelby-like) stress on reference config.
c       at trial state and its isotropic and deviatoric parts
      sx30tr(1:3,1:3) = st30tr(1:3,1:3)-sk30tr(1:3,1:3)
      sx30trv = (sx30tr(1,1)+sx30tr(2,2)+sx30tr(3,3))/3.0d0
      sx30trd(1:3,1:3) = sx30tr(1:3,1:3)-sx30trv*delta(1:3,1:3)
c
c  --- NOTE: norm of deviatoric Mandel stress on intermediate config.
c            is equal to SQRT ( Sdev(i,j) * Sdev(j,i) ), where `S'
c            denotes Eshelby-like stress on reference config.
      dnormxtr = dsqrt( sx30trd(1,1)*sx30trd(1,1)
     &                 +sx30trd(1,2)*sx30trd(2,1)
     &                 +sx30trd(1,3)*sx30trd(3,1)
     &                 +sx30trd(2,1)*sx30trd(1,2)
     &                 +sx30trd(2,2)*sx30trd(2,2)
     &                 +sx30trd(2,3)*sx30trd(3,2)
     &                 +sx30trd(3,1)*sx30trd(1,3)
     &                 +sx30trd(3,2)*sx30trd(2,3)
     &                 +sx30trd(3,3)*sx30trd(3,3) )
c
c ----- isotropic hardening stress at trial state
      CALL plhiso(xpitr,yld0,plhi0,plhi1,plhi2,sitr,tgitr)
c
c ----- check loading criterion
      ftrial = dsqrt(3.0d0/2.0d0)*dnormxtr-rstr*sitr
      felast = dsqrt(3.0d0/2.0d0)*dnormxtr-rse*sitr
c
      if((ftrial.le.0.0d0).or.(felast.le.0.0d0)) then
       idepn = 0
       goto 100
      else if((ftrial.gt.0.0d0).and.(felast.gt.0.0d0)) then
       idepn = 1
       goto 110
      end if
c
c ------ elastic case
  100 continue
c
c   --- initialize incremental plastic multiplier
      dp = 0.0d0
c
c   --- update elastic/plastic/kinematic hardening
c       deformation gradient tensors
      fen(1:3,1:3) = fe(1:3,1:3)
      fpn(1:3,1:3) = fp(1:3,1:3)
c
c   --- update elastic and plastic volume changes
      djen = djn/dsqrt(djcptr)
      djpn = dsqrt(djcptr)
c
c   --- compute Cauchy stress on current config.
c       by push-forward of trial 2nd Piola-Kirchhoff stress on
c       reference config.
      sgn(1:3,1:3) = matmul(ftn(1:3,1:3),
     &                      matmul(st20tr(1:3,1:3),
     &                             transpose(ftn(1:3,1:3))))/djn
c
c   --- update strain variable for isotropic hardening
      xpin = xpitr
c
c   --- update normal-yield ratio for subloading surface
      rsn = dsqrt(3.0d0/2.0d0)*dnormxtr/sitr
c
c   --- update tensor variables for plastic deformation
c       and their determinants
      cpn(1:3,1:3)  = cptr(1:3,1:3)
      cpdn(1:3,1:3) = cpdtr(1:3,1:3)
      djcpn  = djcptr
      djcpdn = djcpdtr
c
c ----- end routine for elastic case
      goto 199
c
c ----- plastic case (execute return mapping algorithm)
  110 continue
c
c   --- initial settings for Newton's iteration
      itmax = 50
      tol = 1.0d-12
c
c   --- initial settings for `reduced' Newton's iteration
      itsmax = 10
      res0s = 1.0d+10
      dk = 1.0d0
c
c   --- initial guess for Newton's iteration
      cpn(1:3,1:3)  = cptr(1:3,1:3)
      cpdn(1:3,1:3) = cpdtr(1:3,1:3)
c
      djcpn  = djcptr
      djcpdn = djcpdtr
c
      xpin = xpitr
c
c   NOTE: initial value for the plastic multiplier `dp' 
c         is taken as zero.
c
      if(rstr.gt.rse) then
       dp = 0.0d0
      else if(rstr.le.rse) then
       dp = 0.0d0
       rstr = rse+(1.0d-12)
      end if
c
      rsn = rstr
c
c   --- begin iteration
      it  = 0
      its = 0
  900 continue
c
c ----- compute inverse of updated values cpn(3,3) and cpdn(3,3)
      cpninv(1:3,1:3)  = cpn(1:3,1:3)
      cpdninv(1:3,1:3) = cpdn(1:3,1:3)
c
      eps = 1.0d-18
      CALL tinvdd(3,cpninv,djcpn,eps,3,iwork,ill)
      CALL tinvdd(3,cpdninv,djcpdn,eps,3,iwork,ill)
c
c ----- compute updated 2nd Piola-Kirchhoff stress on reference config.
c       by neo-Hookean hyperelastic model
      st20n(1:3,1:3)
     & = (dlam/2.0d0)*(djctn/djcpn-1.0d0)*ctninv(1:3,1:3)
     &             +dmyu*(cpninv(1:3,1:3)-ctninv(1:3,1:3))
c
c ----- compute updated (Eshelby-like) stress on reference config.
      st30n(1:3,1:3) = matmul(ctn(1:3,1:3),st20n(1:3,1:3))
c
c ----- 4th-order tangent moduli tensor on reference config.
c       defined as the derivative of (Eshelby-like) stress
c       w.r.t. plastic right Cauchy-Green deformation tensor
      do i=1,3
       do j=1,3
        do k=1,3
         do l=1,3
          tge30cp(i,j,k,l) = 
     &      -(dlam/2.0d0)*(djctn/djcpn)*delta(i,j)*cpninv(l,k)
     &      -dmyu*( ctn(i,1)*cpninv(1,k)*cpninv(l,j)
     &             +ctn(i,2)*cpninv(2,k)*cpninv(l,j)
     &             +ctn(i,3)*cpninv(3,k)*cpninv(l,j) )
         end do
        end do
       end do
      end do
c
c ----- compute updated 2nd Piola-Kirchhoff-type stress variable
c       for kinematic hardening on reference config.
c       by neo-Hookean-type model (only deviatoric part)
      sk20n(1:3,1:3) = dmyuk*(cpdninv(1:3,1:3)-cpninv(1:3,1:3))
c
c ----- convert updated 2nd Piola-Kirchhoff-type stress variable
c       for kinematic hardening to updated (Eshelby-like) back stress
c       on reference config. and compute its isotropic and deviatoric
c       components
      sk30n(1:3,1:3) = matmul(cpn(1:3,1:3),sk20n(1:3,1:3))
      sk30nv = (sk30n(1,1)+sk30n(2,2)+sk30n(3,3))/3.0d0
      sk30nd(1:3,1:3) = sk30n(1:3,1:3)-sk30nv*delta(1:3,1:3)
c
c ----- 4th-order tangent moduli tensors on reference config.
c       defined as the derivative of (Eshelby-like) back stress
c       w.r.t. plastic right Cauchy-Green deformation tensor and
c       deformation variable `cpdn(3,3)' for kinematic hardening
      do i=1,3
       do j=1,3
        do k=1,3
         do l=1,3
          tgk30cp(i,j,k,l)  =  dmyuk*delta(i,k)*cpdninv(l,j)
          tgk30cpd(i,j,k,l) = -dmyuk
     &                   *( cpn(i,1)*cpdninv(1,k)*cpdninv(l,j)
     &                     +cpn(i,2)*cpdninv(2,k)*cpdninv(l,j)
     &                     +cpn(i,3)*cpdninv(3,k)*cpdninv(l,j) )
         end do
        end do
       end do
      end do
c
c ----- compute `reduced' (Eshelby-like) stress on reference config.
c       at updated state and its isotropic and deviatoric parts
      sx30n(1:3,1:3) = st30n-sk30n(1:3,1:3)
      sx30nv = (sx30n(1,1)+sx30n(2,2)+sx30n(3,3))/3.0d0
      sx30nd(1:3,1:3) = sx30n(1:3,1:3)-sx30nv*delta(1:3,1:3)
c
c  --- NOTE: norm of deviatoric Mandel stress on intermediate config.
c            is equal to SQRT ( Sdev(i,j) * Sdev(j,i) ), where `S'
c            denotes Eshelby-like stress on reference config.
      dnormx = dsqrt( sx30nd(1,1)*sx30nd(1,1)
     &               +sx30nd(1,2)*sx30nd(2,1)
     &               +sx30nd(1,3)*sx30nd(3,1)
     &               +sx30nd(2,1)*sx30nd(1,2)
     &               +sx30nd(2,2)*sx30nd(2,2)
     &               +sx30nd(2,3)*sx30nd(3,2)
     &               +sx30nd(3,1)*sx30nd(1,3)
     &               +sx30nd(3,2)*sx30nd(2,3)
     &               +sx30nd(3,3)*sx30nd(3,3) )
c
c   --- to avoid zero-divide
      if(dnormx.lt.1.0d-14) then
       dnormx = 1.0d-14
      end if
c
c   --- isotropic hardening stress at updated state
      CALL plhiso(xpin,yld0,plhi0,plhi1,plhi2,si,tgi)
c
c   --- compute updated normal-yield ratio for subloading surface
c       NOTE: function acos(x) in Fortran is defined
c             on the domain -1 <= x <= +1.
      if(rstr.gt.rse) then
       tmprs = dcos((dpai/2.0d0)*(rstr-rse)/(1.0d0-rse))
     &        *dexp(-u0*(dpai/2.0d0)*(dp/(1.0d0-rse)))
      else if(rstr.le.rse) then
       tmprs = dexp(-u0*(dpai/2.0d0)*(dp/(1.0d0-rse)))
      end if
c
      if(tmprs.gt.1.0d0) then
       tmprs =  1.0d0
      else if(tmprs.lt.-1.0d0) then
       tmprs = -1.0d0
      end if
c
      rsn = rse+(2.0d0/dpai)*(1.0d0-rse)*dacos(tmprs)
c
c   --- definition of directional tensors for plastic evolution eqs.,
c       i.e. plastic flow rule and evolution for kinematic hardening
      gp(1:3,1:3) = 2.0d0*sx30nd(1:3,1:3)/dnormx
      gk(1:3,1:3) = 2.0d0*(plhk/dmyuk)*sk30nd(1:3,1:3)
c
c   --- exponential maps `Qp' and `Qk'
      q1tmp(1:3,1:3) = dp*gp(1:3,1:3)
      q2tmp(1:3,1:3) = dp*gk(1:3,1:3)
c
      nmax = 20
      etol = 1.0d-18
      CALL matexp(nmax,etol,q1tmp,q1exp,ierr)
      CALL matexp(nmax,etol,q2tmp,q2exp,ierr)
c
c   --- residual vector of equations to be solved
      y1(1:3,1:3) = cpn(1:3,1:3)
     &             -matmul(q1exp(1:3,1:3),cptr(1:3,1:3))
      y2(1:3,1:3) = cpdn(1:3,1:3)
     &             -matmul(q2exp(1:3,1:3),cpdtr(1:3,1:3))
      y3 = xpin-xpitr-dsqrt(2.0d0/3.0d0)*dp
      y4 = dsqrt(3.0d0/2.0d0)*dnormx-rsn*si
c
      y( 1) =  y1(1,1)
      y( 2) = (y1(1,2)+y1(2,1))/2.0d0
      y( 3) = (y1(1,3)+y1(3,1))/2.0d0
      y( 4) =  y1(2,2)
      y( 5) = (y1(2,3)+y1(3,2))/2.0d0
      y( 6) =  y1(3,3)
      y( 7) =  y2(1,1)
      y( 8) = (y2(1,2)+y2(2,1))/2.0d0
      y( 9) = (y2(1,3)+y2(3,1))/2.0d0
      y(10) =  y2(2,2)
      y(11) = (y2(2,3)+y2(3,2))/2.0d0
      y(12) =  y2(3,3)
      y(13) = y3
      y(14) = y4
c
c   --- compute norm of residual
      res1 = dsqrt( y( 1)**2+y( 2)**2+y( 3)**2
     &             +y( 4)**2+y( 5)**2+y( 6)**2 )
      res2 = dsqrt( y( 7)**2+y( 8)**2+y( 9)**2
     &             +y(10)**2+y(11)**2+y(12)**2 )
      res3 = dabs(y(13))
      res4 = dabs(y(14))
c
      res = dsqrt(res1**2+res2**2+res3**2+res4**2)
c
c   --- compute norm of residual at the beginning of iteration
      if(it.eq.0) then
       res0 = res
      end if
c
c   --- check rate of convergence, and then, 
c       `reduced' Newton's iteration is employed, if necessary.
      if(    ((res-(1.0d0-dk/4.0d0)*res0s).lt.0.0d0)
     &   .or.(its.ge.itsmax)) then
       its = 0
       res0s = 1.0d+10
       dk = 1.0d0
       goto 899
      else if(     ((res-(1.0d0-dk/4.0d0)*res0s).ge.0.0d0)
     &        .and.(its.lt.itsmax)) then
       its = its+1
       dk = dk/2.0d0
       goto 800
      end if
c
  899 continue
c
c   --- check convergence
      if(res0.gt.1.0d0) then
       resy = res/res0
      else if(res0.le.1.0d0) then
       resy = res
      end if
c
      write(iow1,555) it,resy,res1,res2,res3,res4
  555 format(i5,5es12.4)
c
      if(resy.lt.tol) then
       goto 990
      else if((it.ge.itmax).and.(resy.ge.tol)) then
       write(iow1,500) '--- return mapping failed.',
     &                 ' it =',it,' res =',resy,' at',
     &                 ' inel =',inel,' ige =',ige,'.'
  500  format(a26,a5,i3,a6,1pd12.4,a3,a7,i8,a6,i3,a1)
       goto 990
      else
       it = it+1
      end if
c
c   --- 1st derivative of the subloading function w.r.t.
c       (Eshelby-like) stress variables on reference config.
c       (note the transpose of the stress tensor in numerator),
c       scalar stress variable for isotropic hardening, and
c       normal-yield ratio
      dfst(1:3,1:3) =  dsqrt(3.0d0/2.0d0)
     &                *transpose(sx30nd(1:3,1:3))/dnormx
      dfsk(1:3,1:3) = -dsqrt(3.0d0/2.0d0)
     &                *transpose(sx30nd(1:3,1:3))/dnormx
      dfsi = -rsn
      dfrs = -si
c
c   --- 1st derivatives of directional tensors `gp(3,3)' and `gk(3,3)'
c       for plastic evolution w.r.t. `reduced' (Eshelby-like) stress 
c       and (Eshelby-like) back stress on reference config.
c       (note the transpose `sx30nd(l,k)' of the latter tensor
c        in the last term)
      do i=1,3
       do j=1,3
        do k=1,3
         do l=1,3
          dgp(i,j,k,l) = 2.0d0*(1.0d0/dnormx)
     &                 *( delta(i,k)*delta(j,l)
     &                   -delta(i,j)*delta(k,l)/3.0d0
     &                   -(sx30nd(i,j)/dnormx)*(sx30nd(l,k)/dnormx) )
          dgk(i,j,k,l) = 2.0d0*(plhk/dmyuk)
     &                        *( delta(i,k)*delta(j,l)
     &                          -delta(i,j)*delta(k,l)/3.0d0)
         end do
        end do
       end do
      end do
c
c   --- derivative of normal-yield ratio w.r.t. incremental
c       plastic multiplier 
c       (zero-divide should be avoided and `drs' must be non-negative
c        even when `rsn' is less than or equal to `rse')
      tmprs = (dpai/2.0d0)*(rsn-rse)/(1.0d0-rse)
c
      if(tmprs.ge.1.0d-08) then
       drs = u0*dexp(-u0*(dpai/2.0d0)*(dp/(1.0d0-rse)))
     &         *dcos((dpai/2.0d0)*(rstr-rse)/(1.0d0-rse))
     &         /dsin((dpai/2.0d0)*(rsn-rse)/(1.0d0-rse))
      else if(tmprs.lt.1.0d-08) then
       drs = u0*dexp(-u0*(dpai/2.0d0)*(dp/(1.0d0-rse)))
     &         *dcos((dpai/2.0d0)*(rstr-rse)/(1.0d0-rse))
     &         /(1.0d-08)
      end if
c
c   --- compute derivative of exponential map
c       d exp[A(i,j)]/ d A(i,j)
      nmax = 20
      etol = 1.0d-18
      CALL matdex(nmax,etol,q1tmp,dq1exp,ierr)
      CALL matdex(nmax,etol,q2tmp,dq2exp,ierr)
c
c   --- derivative of exponential map `Qp'
      do i=1,3
       do j=1,3
        do k=1,3
         do l=1,3
          tmp11(i,j,k,l) = 0.0d0
          tmp12(i,j,k,l) = 0.0d0
          do m=1,3
           do n=1,3
            tmp11(i,j,k,l) = tmp11(i,j,k,l)
     &        +dp*dgp(i,j,m,n)*(tge30cp(m,n,k,l)-tgk30cp(m,n,k,l))
            tmp12(i,j,k,l) = tmp12(i,j,k,l)
     &        -dp*dgp(i,j,m,n)*tgk30cpd(m,n,k,l)
           end do
          end do
         end do
        end do
       end do
      end do
c
      do i=1,3
       do j=1,3
        dq13(i,j) = 0.0d0
        dq14(i,j) = 0.0d0
        do k=1,3
         do l=1,3
          dq11(i,j,k,l) = 0.0d0
          dq12(i,j,k,l) = 0.0d0
          dq14(i,j) = dq14(i,j)+dq1exp(i,j,k,l)*gp(k,l)
          do m=1,3
           do n=1,3
            dq11(i,j,k,l) = dq11(i,j,k,l)
     &        +dq1exp(i,j,m,n)*tmp11(m,n,k,l)
            dq12(i,j,k,l) = dq12(i,j,k,l)
     &        +dq1exp(i,j,m,n)*tmp12(m,n,k,l)
           end do
          end do
         end do
        end do
       end do
      end do
c
c   --- derivative of exponential map `Qk'
      do i=1,3
       do j=1,3
        do k=1,3
         do l=1,3
          tmp21(i,j,k,l) = 0.0d0
          tmp22(i,j,k,l) = 0.0d0
          do m=1,3
           do n=1,3
            tmp21(i,j,k,l) = tmp21(i,j,k,l)
     &        +dp*dgk(i,j,m,n)*tgk30cp(m,n,k,l)
            tmp22(i,j,k,l) = tmp22(i,j,k,l)
     &        +dp*dgk(i,j,m,n)*tgk30cpd(m,n,k,l)
           end do
          end do
         end do
        end do
       end do
      end do
c
      do i=1,3
       do j=1,3
        dq23(i,j) = 0.0d0
        dq24(i,j) = 0.0d0
        do k=1,3
         do l=1,3
          dq21(i,j,k,l) = 0.0d0
          dq22(i,j,k,l) = 0.0d0
          dq24(i,j) = dq24(i,j)+dq2exp(i,j,k,l)*gk(k,l)
          do m=1,3
           do n=1,3
            dq21(i,j,k,l) = dq21(i,j,k,l) 
     &        +dq2exp(i,j,m,n)*tmp21(m,n,k,l)
            dq22(i,j,k,l) = dq22(i,j,k,l)
     &        +dq2exp(i,j,m,n)*tmp22(m,n,k,l)
           end do
          end do
         end do
        end do
       end do
      end do
c
c   --- Jacobian matrix of return-mapping equations
c
c     --- equation (1) of plastic flow
      do i=1,3
       do j=1,3
        do k=1,3
         do l=1,3
          aj11(i,j,k,l) = 0.50d0*( delta(i,k)*delta(j,l)
     &                            +delta(i,l)*delta(j,k) )
          aj12(i,j,k,l) = 0.0d0
          do m=1,3
           aj11(i,j,k,l) = aj11(i,j,k,l)-dq11(i,m,k,l)*cptr(m,j)
           aj12(i,j,k,l) = aj12(i,j,k,l)-dq12(i,m,k,l)*cptr(m,j)
          end do
         end do
        end do
       end do
      end do
      aj13(1:3,1:3) = -matmul(dq13(1:3,1:3),cptr(1:3,1:3))
      aj14(1:3,1:3) = -matmul(dq14(1:3,1:3),cptr(1:3,1:3))
c
c     --- equation (2) of kinematic hardening
      do i=1,3
       do j=1,3
        do k=1,3
         do l=1,3
          aj21(i,j,k,l) = 0.0d0
          aj22(i,j,k,l) = 0.50d0*( delta(i,k)*delta(j,l)
     &                            +delta(i,l)*delta(j,k) )
          do m =1,3
           aj21(i,j,k,l) = aj21(i,j,k,l)-dq21(i,m,k,l)*cpdtr(m,j)
           aj22(i,j,k,l) = aj22(i,j,k,l)-dq22(i,m,k,l)*cpdtr(m,j)
          end do
         end do
        end do
       end do
      end do
      aj23(1:3,1:3) = -matmul(dq23(1:3,1:3),cpdtr(1:3,1:3))
      aj24(1:3,1:3) = -matmul(dq24(1:3,1:3),cpdtr(1:3,1:3))
c
c     --- equation (3) of isotropic hardening
      aj31(1:3,1:3) = 0.0d0
      aj32(1:3,1:3) = 0.0d0
      aj33 =  1.0d0
      aj34 = -dsqrt(2.0d0/3.0d0)
c
c     --- equation (4) of yield function
      do i=1,3
       do j=1,3
        aj41(i,j) = 0.0d0
        aj42(i,j) = 0.0d0
        do m=1,3
         do n=1,3
          aj41(i,j) = aj41(i,j)+dfst(m,n)*tge30cp(m,n,i,j)
     &                         +dfsk(m,n)*tgk30cp(m,n,i,j)
          aj42(i,j) = aj42(i,j)+dfsk(m,n)*tgk30cpd(m,n,i,j)
         end do
        end do
       end do
      end do
c
      aj43 = dfsi*tgi
      aj44 = dfrs*drs
c
c   --- assemble Jacobian matrix [14x14]
      m = 0
      do i=1,3
      do j=i,3
       m = m+1
       n = 0
       do k=1,3
       do l=k,3
        n = n+1
        aj(  m,  n) = ( aj11(i,j,k,l)
     &                 +aj11(j,i,k,l)
     &                 +aj11(i,j,l,k)
     &                 +aj11(j,i,l,k) )/4.0d0
        aj(  m,6+n) = ( aj12(i,j,k,l)
     &                 +aj12(j,i,k,l)
     &                 +aj12(i,j,l,k)
     &                 +aj12(j,i,l,k) )/4.0d0
        aj(6+m,  n) = ( aj21(i,j,k,l)
     &                 +aj21(j,i,k,l)
     &                 +aj21(i,j,l,k)
     &                 +aj21(j,i,l,k) )/4.0d0
        aj(6+m,6+n) = ( aj22(i,j,k,l)
     &                 +aj22(j,i,k,l)
     &                 +aj22(i,j,l,k)
     &                 +aj22(j,i,l,k) )/4.0d0
       end do
       end do
      end do
      end do
c
      m = 0
      do i=1,3
       do j=i,3
        m = m+1
        aj(  m,13) = (aj13(i,j)+aj13(j,i))/2.0d0
        aj(6+m,13) = (aj23(i,j)+aj23(j,i))/2.0d0
        aj(  m,14) = (aj14(i,j)+aj14(j,i))/2.0d0
        aj(6+m,14) = (aj24(i,j)+aj24(j,i))/2.0d0
        aj(13,  m) = (aj31(i,j)+aj31(j,i))/2.0d0
        aj(13,6+m) = (aj32(i,j)+aj32(j,i))/2.0d0
        aj(14,  m) = (aj41(i,j)+aj41(j,i))/2.0d0
        aj(14,6+m) = (aj42(i,j)+aj42(j,i))/2.0d0
       end do
      end do
c
      aj(13,13) = aj33
      aj(13,14) = aj34
      aj(14,13) = aj43
      aj(14,14) = aj44
c
c   --- solve simultaneous equations
      do k=1,14
       y(k) = -y(k)
      end do
c
      eps = 1.0d-20
      CALL tledd(14,aj,y,dx,14,eps,ill)
c
c     --- before conducting `reduced' Newton's iteration, 
c         variables before update are saved
      if(its.eq.0) then
       res0s = res
       x1( 1) =  cpn(1,1)
       x1( 2) = (cpn(1,2)+cpn(2,1))/2.0d0
       x1( 3) = (cpn(1,3)+cpn(3,1))/2.0d0
       x1( 4) =  cpn(2,2)
       x1( 5) = (cpn(2,3)+cpn(3,2))/2.0d0
       x1( 6) =  cpn(3,3)
       x1( 7) =  cpdn(1,1)
       x1( 8) = (cpdn(1,2)+cpdn(2,1))/2.0d0
       x1( 9) = (cpdn(1,3)+cpdn(3,1))/2.0d0
       x1(10) =  cpdn(2,2)
       x1(11) = (cpdn(2,3)+cpdn(3,2))/2.0d0
       x1(12) =  cpdn(3,3)
       x1(13) = xpin
       x1(14) = dp
      end if
c
c     --- update variables (loop 800: `reduced' Newton's iteration)
  800 continue
c
      cpn(1,1)  = x1( 1)+dk*dx( 1)
      cpn(1,2)  = x1( 2)+dk*dx( 2)/2.0d0
      cpn(1,3)  = x1( 3)+dk*dx( 3)/2.0d0
      cpn(2,1)  = x1( 2)+dk*dx( 2)/2.0d0
      cpn(2,2)  = x1( 4)+dk*dx( 4)
      cpn(2,3)  = x1( 5)+dk*dx( 5)/2.0d0
      cpn(3,1)  = x1( 3)+dk*dx( 3)/2.0d0
      cpn(3,2)  = x1( 5)+dk*dx( 5)/2.0d0
      cpn(3,3)  = x1( 6)+dk*dx( 6)
c
      cpdn(1,1) = x1( 7)+dk*dx( 7)
      cpdn(1,2) = x1( 8)+dk*dx( 8)/2.0d0
      cpdn(1,3) = x1( 9)+dk*dx( 9)/2.0d0
      cpdn(2,1) = x1( 8)+dk*dx( 8)/2.0d0
      cpdn(2,2) = x1(10)+dk*dx(10)
      cpdn(2,3) = x1(11)+dk*dx(11)/2.0d0
      cpdn(3,1) = x1( 9)+dk*dx( 9)/2.0d0
      cpdn(3,2) = x1(11)+dk*dx(11)/2.0d0
      cpdn(3,3) = x1(12)+dk*dx(12)
c
      xpin      = x1(13)+dk*dx(13)
      dp        = x1(14)+dk*dx(14)
c
c   --- go to next iteration
      goto 900
c
c   --- end of iteration
  990 continue
c
      if(dp.lt.0.0d0) then
       write(iow1,*) '--- negative plastic multiplier ',dp,' at',
     &               ' inel =',inel,' ige =',ige,'.'
       stop
      end if
c
c ----- update variables
c
c   --- update elastic and plastic deformation gradient tensors
      fen(1:3,1:3) = fe(1:3,1:3)
      fpn(1:3,1:3) = fp(1:3,1:3)
c
c   --- update elastic and plastic volume changes
      djen = djn/dsqrt(djcpn)
      djpn = dsqrt(djcpn)
c
c   --- compute updated Cauchy stress by push-forward operation of
c       2nd Piola-Kirchhoff stress from reference config. to current
c       config.
      sgn(1:3,1:3) = matmul(ftn(1:3,1:3),
     &                      matmul(st20n(1:3,1:3),
     &                             transpose(ftn(1:3,1:3))))/djn
c
c ----- end routine for plastic case
      goto 199
c
c ----- end of return mapping routine
  199 continue
c
c ----- update plastic internal variables
      xpn( 1) = dp
      xpn( 2) = xpin
      xpn( 3) = rsn
      xpn( 4) = 0.0d0
      xpn( 5) = 0.0d0
      xpn( 6) = 0.0d0
      xpn( 7) = 0.0d0
      xpn( 8) = 0.0d0
      xpn( 9) = 0.0d0
      xpn(10) = 0.0d0
      xpn(11) = cpn(1,1)
      xpn(12) = cpn(1,2)
      xpn(13) = cpn(1,3)
      xpn(14) = cpn(2,1)
      xpn(15) = cpn(2,2)
      xpn(16) = cpn(2,3)
      xpn(17) = cpn(3,1)
      xpn(18) = cpn(3,2)
      xpn(19) = cpn(3,3)
      xpn(20) = djcpn
      xpn(21) = cpdn(1,1)
      xpn(22) = cpdn(1,2)
      xpn(23) = cpdn(1,3)
      xpn(24) = cpdn(2,1)
      xpn(25) = cpdn(2,2)
      xpn(26) = cpdn(2,3)
      xpn(27) = cpdn(3,1)
      xpn(28) = cpdn(3,2)
      xpn(29) = cpdn(3,3)
      xpn(30) = djcpdn
c
      return
      end subroutine retmap
