      program returnmap  ! Copyright (c) 2012-2013 Yuki Yamakawa.
      parameter ( lstep = 10 )
      implicit double precision (a-h,o-z)
      dimension nbgn(lstep),nend(lstep),frx(lstep,3,3)
      dimension prope(20)
      dimension fr(3,3)
      dimension ft(3,3),fe(3,3),fp(3,3),sg(3,3),xp(30)
      dimension ftn(3,3),fen(3,3),fpn(3,3),sgn(3,3),xpn(30)
      dimension cep(3,3,3,3)
      character*7 charin
      common /iofile/ior1,ior2,ior3,ior4,ior5,
     &               iow1,iow2,iow3,iow4,iow5,
     &               iow6,iow7,iow8,iow9,iow10
      data ior1,ior2,ior3,ior4,ior5 / 1, 2, 3, 4, 5/
     &     iow1,iow2,iow3,iow4,iow5 /11,12,13,14,15/
     &     iow6,iow7,iow8,iow9,iow10/16,17,18,19,20/
      common /etc/del(3),delta(3,3),p(3,3,3),dpai
c
c ----- define common block /etc/ 
      CALL comvar
c
c ----- open files
      open(ior1,file='input.txt',status='old')
      open(iow1,file='logfile.txt',status='unknown')
      open(iow2,file='output1.txt',status='unknown')
c
c ----- read relative deformation gradient for each loading step
      read(ior1,'(a)') charin
      if(charin.eq.'/RDGRD/') then
       read(ior1,540) mstep
  540  format(i5)
       if(mstep.gt.lstep) then
        write(*,*) '--- ERROR. Increase `lstep'' parameter.'
        stop
       end if
       ichk1 = 0
       do kstep=1,mstep
        read(ior1,541) jstep,nbgn(kstep),nend(kstep)
  541   format(i5,2i8)
        if(jstep.eq.kstep) then
         ichk1 = ichk1+1
        end if
        read(ior1,542) frx(kstep,1,1),frx(kstep,1,2),frx(kstep,1,3)
        read(ior1,542) frx(kstep,2,1),frx(kstep,2,2),frx(kstep,2,3)
        read(ior1,542) frx(kstep,3,1),frx(kstep,3,2),frx(kstep,3,3)
  542   format(3es15.7)
       end do
       ichk2 = 0
       do kstep=1,mstep-1
        if((nend(kstep)+1).eq.nbgn(kstep+1)) then
         ichk2 = ichk2+1
        end if
       end do
       if(     (ichk1.eq.mstep).and.(ichk2.eq.(mstep-1))
     &    .and.(nbgn(1).eq.1) ) then
       else
        write(*,*) '--- invalid loading step setting.'
        stop
       end if
       nstep = nend(mstep)
      end if
c
c ----- material constants
      read(ior1,'(a)') charin
      if(charin.eq.'/MATER/') then
       read(ior1,550) (prope(k),k= 1, 5)
       read(ior1,550) (prope(k),k= 6,10)
       read(ior1,550) (prope(k),k=11,15)
       read(ior1,550) (prope(k),k=16,20)
  550  format(5es12.4)
      end if
c
c ----- Cauchy stress at reference state
      read(ior1,'(a)') charin
      if(charin.eq.'/STRES/') then
       read(ior1,551) idum,idum,
     &                sg(1,1),sg(1,2),sg(1,3),
     &                sg(2,1),sg(2,2),sg(2,3),
     &                sg(3,1),sg(3,2),sg(3,3),
     &                dum,idep,idum
  551  format(i8,i5,10es15.7,2i5)
      end if
c
c ----- plastic internal variables at reference state
      read(ior1,'(a)') charin
      if(charin.eq.'/PLAST/') then
       read(ior1,552) idum,idum,(xp(k),k=1,30)
  552  format(i8,i5,30es15.7)
      end if
c
c ----- initialize deformation gradient and volume change
      ft(1:3,1:3) = delta(1:3,1:3)
      fe(1:3,1:3) = delta(1:3,1:3)
      fp(1:3,1:3) = delta(1:3,1:3)
c
      dj  = 1.0d0
      dje = 1.0d0
      djp = 1.0d0
c
c ----- output the reference state
      write(iow2,505) 'istep','idn',
     &                'djn ','djen','djpn',
     &                'ft11','ft12','ft13',
     &                'ft21','ft22','ft23',
     &                'ft31','ft32','ft33',
     &                'sg11','sg12','sg13',
     &                'sg21','sg22','sg23',
     &                'sg31','sg32','sg33',
     &                'xp01','xp02','xp03','xp04','xp05',
     &                'xp06','xp07','xp08','xp09','xp10',
     &                'xp11','xp12','xp13','xp14','xp15',
     &                'xp16','xp17','xp18','xp19','xp20',
     &                'xp21','xp22','xp23','xp24','xp25',
     &                'xp26','xp27','xp28','xp29','xp30'
c
  505 format('( 1)',a5,1x,'( 2)',a3,1x,
     &'( 3)',a4,7x,'( 4)',a4,7x,'( 5)',a4,7x,
     &'( 6)',a4,7x,'( 7)',a4,7x,'( 8)',a4,7x,
     &'( 9)',a4,7x,'(10)',a4,7x,'(11)',a4,7x,
     &'(12)',a4,7x,'(13)',a4,7x,'(14)',a4,7x,
     &'(15)',a4,7x,'(16)',a4,7x,'(17)',a4,7x,
     &'(18)',a4,7x,'(19)',a4,7x,'(20)',a4,7x,
     &'(21)',a4,7x,'(22)',a4,7x,'(23)',a4,7x,
     &'(24)',a4,7x,'(25)',a4,7x,'(26)',a4,7x,'(27)',a4,7x,'(28)',a4,7x,
     &'(29)',a4,7x,'(30)',a4,7x,'(31)',a4,7x,'(32)',a4,7x,'(33)',a4,7x,
     &'(34)',a4,7x,'(35)',a4,7x,'(36)',a4,7x,'(37)',a4,7x,'(38)',a4,7x,
     &'(39)',a4,7x,'(40)',a4,7x,'(41)',a4,7x,'(42)',a4,7x,'(43)',a4,7x,
     &'(44)',a4,7x,'(45)',a4,7x,'(46)',a4,7x,'(47)',a4,7x,'(48)',a4,7x,
     &'(49)',a4,7x,'(50)',a4,7x,'(51)',a4,7x,'(52)',a4,7x,'(53)',a4,7x)
c
      write(iow2,512) 0,idep,
     &                dj,dje,djp,
     &                ft(1,1),ft(1,2),ft(1,3),
     &                ft(2,1),ft(2,2),ft(2,3),
     &                ft(3,1),ft(3,2),ft(3,3),
     &                sg(1,1),sg(1,2),sg(1,3),
     &                sg(2,1),sg(2,2),sg(2,3),
     &                sg(3,1),sg(3,2),sg(3,3),
     &                (xp(k),k=1,30)
c
c ----- incremental loading steps [do-loop: 100]
      do 100 istep=1,nstep
c
c ----- define relative deformation gradient
       ichk = 0
       do kstep=1,mstep
        kbgn = nbgn(kstep)
        kend = nend(kstep)
        if((kbgn.le.istep).and.(istep.le.kend)) then
         fr(1:3,1:3) = frx(kstep,1:3,1:3)
         ichk = ichk+1
        end if
       end do
c
       if(ichk.ne.1) then
        write(*,*) '--- invalid loading step setting.'
        stop
       end if
c
c ----- update total deformation gradient
       ftn(1:3,1:3) = matmul(fr(1:3,1:3),ft(1:3,1:3))
c
c ----- compute determinant of updated total deformation gradient
      djn =  ftn(1,1)*ftn(2,2)*ftn(3,3)
     &     + ftn(1,3)*ftn(2,1)*ftn(3,2)
     &     + ftn(3,1)*ftn(1,2)*ftn(2,3)
     &     - ftn(1,3)*ftn(2,2)*ftn(3,1)
     &     - ftn(1,1)*ftn(2,3)*ftn(3,2)
     &     - ftn(3,3)*ftn(1,2)*ftn(2,1)
c
c ----- initialize the plastic multiplier
      dp = 0.0d0
c
c ----- return-mapping algorithm
      write(iow1,*) 'Load step: ',istep
c
      CALL retmap(inel,ige,mtypee,prope,
     &            fr,djr,
     &            ft,dj,fe,dje,fp,djp,sg,idep,xp,
     &            ftn,djn,fen,djen,fpn,djpn,sgn,idepn,xpn)
c
c ----- output updated result
      write(iow2,512) istep,idepn,
     &                djn,djen,djpn,
     &                ftn(1,1),ftn(1,2),ftn(1,3),
     &                ftn(2,1),ftn(2,2),ftn(2,3),
     &                ftn(3,1),ftn(3,2),ftn(3,3),
     &                sgn(1,1),sgn(1,2),sgn(1,3),
     &                sgn(2,1),sgn(2,2),sgn(2,3),
     &                sgn(3,1),sgn(3,2),sgn(3,3),
     &                (xpn(k),k=1,30)
  512 format(2i8,3es15.7,9es15.7,9es15.7,30es15.7)
c
c ----- update variables
      ft(1:3,1:3) = ftn(1:3,1:3)
      fe(1:3,1:3) = fen(1:3,1:3)
      fp(1:3,1:3) = fpn(1:3,1:3)
      sg(1:3,1:3) = sgn(1:3,1:3)
c
      dj  = djn
      dje = djen
      djp = djpn
c
      xp(1:30) = xpn(1:30)
c
      idep = idepn
c
c ----- end of loading steps [loop = 100]
  100 continue
c
c ----- close files
      close(ior1)
      close(iow1)
      close(iow2)
      close(iow3)
      close(iow4)
      close(iow5)
c
c ----- end of program
      stop
      end program returnmap
