      subroutine tgnum0(inel,ige,mtypee,prope,
     &                  cep,epsx,
     &                  ft,dj,fe,dje,fp,djp,sg,idep,xp,
     &                  ftn,djn,sgn)
      implicit double precision (a-h,o-z)
      dimension prope(20),bv0x(3,3),cep(3,3,3,3)
      dimension ft(3,3),fe(3,3),fp(3,3),sg(3,3),xp(30)
      dimension ftn(3,3),sgn(3,3)
      dimension ftinv(3,3),ftninv(3,3),ftxinv(3,3),iwork(6),frx(3,3)
      dimension ftx(3,3),fex(3,3),fpx(3,3),sgx(3,3),xpx(30)
      dimension st2n(3,3),st2x(3,3)
      common /iofile/ior1,ior2,ior3,ior4,ior5,
     &               iow1,iow2,iow3,iow4,iow5,
     &               iow6,iow7,iow8,iow9,iow10
      common /etc/del(3),delta(3,3),p(3,3,3),dpai
c
c ----- computation of algorithmic (consistent) tangent moduli tensor
c       by the numerical differentiation using a perturbation technique
c
c       *) type-0: Lagrangian geometric setting
c
c ----- inverse of total deformation gradient at `t_n' and `t_n+1'
      ftinv(1:3,1:3)  = ft(1:3,1:3)
      ftninv(1:3,1:3) = ftn(1:3,1:3)
      eps = 1.0d-18
      CALL tinvdd(3,ftinv,detft,eps,3,iwork,ill1)
      CALL tinvdd(3,ftninv,detftn,eps,3,iwork,ill2)
c
c ----- compute for row indices
c         (K,L) = (1,1),(1,2),(1,3),(2,2),(2,3),(3,3)
      do 100 k=1,3
      do 200 l=k,3
c
c ----- compute perturbed deformation gradient
      do i=1,3
       do j=1,3
        ftx(i,j) = ftn(i,j)
     &            +(epsx/2.0d0)*( ftninv(k,i)*delta(l,j)
     &                           +ftninv(l,i)*delta(k,j) )
       enddo
      enddo
c
c ----- compute Jacobian of the perturbed deformation gradient
      djx = ftx(1,1)*ftx(2,2)*ftx(3,3)
     &     +ftx(1,3)*ftx(2,1)*ftx(3,2)
     &     +ftx(3,1)*ftx(1,2)*ftx(2,3)
     &     -ftx(1,3)*ftx(2,2)*ftx(3,1)
     &     -ftx(1,1)*ftx(2,3)*ftx(3,2)
     &     -ftx(3,3)*ftx(1,2)*ftx(2,1)
c
c ----- inverse of perturbed deformation gradient
      ftxinv(1:3,1:3) = ftx(1:3,1:3)
      eps = 1.0d-18
      CALL tinvdd(3,ftxinv,detftx,eps,3,iwork,ill1)
c
c ----- compute relative deformation gradient between
c       the configurations at `t_n' and the perturbed state
      frx(1:3,1:3) = matmul(ftx(1:3,1:3),ftinv(1:3,1:3))
c
c ----- compute determinant of relative deformation gradient
      djrx = frx(1,1)*frx(2,2)*frx(3,3)
     &      +frx(1,3)*frx(2,1)*frx(3,2)
     &      +frx(3,1)*frx(1,2)*frx(2,3)
     &      -frx(1,3)*frx(2,2)*frx(3,1)
     &      -frx(1,1)*frx(2,3)*frx(3,2)
     &      -frx(3,3)*frx(1,2)*frx(2,1)
c
c ----- return mapping algorithm
       CALL retmap(inel,ige,mtypee,prope,
     &             frx,djrx,
     &             ft,dj,fe,dje,fp,djp,sg,idep,xp,
     &             ftx,djx,fex,djex,fpx,djpx,sgx,idepx,xpx)
c
c ----- compute 2nd Piola-Kirchhoff stress by pull-back operation
      st2n(1:3,1:3) = matmul(ftninv(1:3,1:3),
     &                       matmul(djn*sgn(1:3,1:3),
     &                              transpose(ftninv(1:3,1:3))))
      st2x(1:3,1:3) = matmul(ftxinv(1:3,1:3),
     &                       matmul(djx*sgx(1:3,1:3),
     &                              transpose(ftxinv(1:3,1:3))))
c
c ----- compute Lagrangian algorithmic tangent moduli
      do i=1,3
       do j=1,3
        cep(i,j,k,l) = (st2x(i,j)-st2n(i,j))/epsx
        cep(i,j,l,k) = cep(i,j,k,l)
       end do
      end do
c
  200 continue
  100 continue
c
      return
      end subroutine tgnum0
