CTLEDD        0006F ; COMPUTER CENTER TOHOKU UNIVERSITY
C  ********** LIBRARY HEADER ********************
C00  F4/CTU0006F/TLEDD ;COMPUTER CENTER TOHOKU UNIVERSITY
C10  TLEDD ;LINEAR EQUATION,ELIMINATION    (DOUBLE PRECISION)
C20  SUBROUTINE
C30  710430;SAKATA MASATO
C40
C50
C60  ACOS SERIES 77 NEAC SYSTEM 700;ACOS-6,R3.1
C61  ACOS SERIES 77 NEAC SYSTEM 900;ACOS-6,R5.2(BIN,HEX)
C70  LP=6
C80  CM=949W
C90
C  **********************************************
      SUBROUTINE   TLEDD(N,A,B,X,NN,E,INDER)
C
C  THE SOLUTION OF LINEAR EQUATION OF TYPE
C          AX=B       A-  N*N  MATRIX
C      BY  GAUSSIAN ELIMINATION
      DOUBLE PRECISION   A,B,X,E,PIV,PMAX,EPS,F,AA,WORK
      DIMENSION  A(NN,N) , B(N) , X(N)
      INDER=0
      NM1   =  N-1
      IF(NM1)                  40,41,42
   40 INDER =  -1000
      WRITE(6,640)   N
  640 FORMAT(1H0,8H *** N =,I5,5X,30H N SHOULD BE POSITIVE IN TLEDD  )
      RETURN
   41 X(1)  =  B(1)/A(1,1)
      IF(A(1,1).EQ.0.0D0)  GO TO   21
      RETURN
   42 IF(N.LE.NN)       GO TO     43
      INDER =  -1001
      WRITE(6,642)   N,NN
  642 FORMAT(1H0,8H *** N =,I5,5X,8H *** NN=,I5,
     &/1H ,55H     NN SHOULD BE GREATER THAN OR EQUAL TO N IN TLEDD  )
      RETURN
   43 PIV  =  0.0D0
      DO    1     I=1,N
      DO    1     J=1,N
      IF(DABS(A(I,J)).LE.PIV)    GO TO  1
      PIV   =  DABS(A(I,J))
      L     =  I
      M     =  J
    1 CONTINUE
      IF(PIV.EQ.0.0D0)         GO TO  21
      EPS  =  E*PIV
      DO   2   K=1,NM1
      KK   = K+1
      X(K) = M
      IF(K.EQ.L)   GO TO  4
      DO   3   J=K,N
      WORK  =  A(K,J)
      A(K,J)=  A(L,J)
    3 A(L,J)=  WORK
      WORK  =  B(K)
      B(K)  =  B(L)
      B(L)  =  WORK
    4 IF(K.EQ.M)    GO TO  6
      DO   5   I=1,N
      WORK  =  A(I,K)
      A(I,K)=  A(I,M)
    5 A(I,M)=  WORK
    6 PMAX  =  1.0D0/A(K,K)
      PIV   =  0.0D0
      DO   7   I=KK,N
      AA    =  A(I,K)*PMAX
      DO   8   J=KK,N
      A(I,J)=  A(I,J)-A(K,J)*AA
      WORK  =  DABS(A(I,J))
      IF(WORK.LE.PIV)   GO TO  8
      PIV   =  WORK
      M     =  J
      L     =  I
    8 CONTINUE
    7 B(I)  =  B(I)-B(K)*AA
      IF(PIV.LE.EPS)          GO TO  22
    2 CONTINUE
      GO TO    10
   22 DO  20    I=KK,N
      IF(DABS(B(I)).GT.EPS)   GO TO  25
      B(I)   =  0.0D0
   20 X(I)  =  I
      INDER =  N-KK+1
      WRITE(6,610)    K
      L     =  N-K+2
      B(K)  =  B(K)/A(K,K)
      IF(K.EQ.1)   GO TO  15
      GO TO   16
   21 K     =  0
      KK    =  1
   25 INDER =  -(N-KK+1)
      WRITE(6,611)    K
      RETURN
  610 FORMAT(1H0,51H***LINEAR EQUATION AX=B TO TLEDD IS ILL CONDITIONED
     &,28H OR INDETERMINATE WITH RANK=,I4
     &/1H ,4X,51HSOLUTION CAN BE EXPRESSED BY B+A*Y WHERE           
     &, 30HY IS AN ARBITRARY VECTOR                      )
  611 FORMAT(1H0,51H***LINEAR EQUATION AX=B TO TLEDD IS ILL CONDITIONED
     &,28H OR INCONSISTENT  WITH RANK=,I4,
     & 38H.   RETURN WITH NO FURTHER CALCULATION   )
C
   10 B(N)  =  B(N)/A(N,N)
      L     =  2
   16 DO  11   II=L,N
      I     =  N+1-II
      F     =  B(I)
      IM1   =  I+1
      DO  12  J=IM1,N
   12 F     =  F-A(I,J)*B(J)
   11 B(I)  =  F/A(I,I)
   15 DO  13   II=2,N
      I     =  N+1-II
      M     =  X(I)
      WORK  =  B(I)
      B(I)  =  B(M)
   13 B(M)  =  WORK
      IF(INDER.NE.0)          GO TO  30
   17 DO  14   I=1,N
   14 X(I)  =  B(I)
      RETURN
   30 DO  50   J=KK,N
      DO  52  II=1,K
      I     =  K-II+1
      F     =  A(I,J)
      IM1   =  I+1
      IF(II.EQ.1)     GO TO  52
      DO  51   M=IM1,K
   51 F     =  F+A(I,M)*A(M,J)
   52 A(I,J)=  -F/A(I,I)
   50 CONTINUE
      DO  31   I=1,N
      DO  32   J=1,N
   32 IF(I.GE.KK.OR.J.LT.KK)   A(I,J)=0.0
   31 IF(I.GE.KK)     A(I,I)=1.0D0
   33 M     =  X(K)
      IF(M.EQ.K)    GO TO  35
      DO  34   I=KK,N
      WORK  =  A(K,I)
      A(K,I)=  A(M,I)
   34 A(M,I)=  WORK
   35 K     =  K-1
      IF(K.NE.0)    GO TO  33
      GO TO   17
      END
